#!/usr/bin/env node

var doc_output_path = './' // output to folder of this file
var file_extension = 'liquid'
if (process.argv.length > 3){
     doc_output_path = process.argv[3] + "/"  // output to folder being analysed
}

var dir = "."
if (process.argv.length > 2){ dir = process.argv[2] }
var override_filename = false;
if (process.argv.length > 4){ override_filename = process.argv[4] }
var override_fileintro = false;
if (process.argv.length > 5){ override_fileintro = process.argv[5] }

// console.log(process.argv);

var chunks_output = [];
var itemsProcessed = 0;
var total_file_count = 0;
var fs = require('fs');
var path = require('path');
var walk = function(dir, done) {
  var results = [];
  fs.readdir(dir, function(err, list) {
    if (err) return done(err);
    var pending = list.length;
    if (!pending) return done(null, results);
    list.forEach(function(file) {
      file = path.resolve(dir, file);
      fs.stat(file, function(err, stat) {
        var extension = file;
        extension = extension.split('.').pop()
        if (stat && stat.isDirectory()) {
          walk(file, function(err, res) {
            results = results.concat(res);
            if (!--pending) done(null, results);
          });
        } else  {
            if( extension == file_extension ){
                results.push(file);
            }
            if (!--pending) done(null, results);
        }
      });
    });
  });
};

var callback = function(nothing, data){
    total_file_count = data.length;
    data.forEach(function(el, els, i){
        readData(el);
    })
}

var readData = function(path){
    var fs = require('fs'),
    es = require('event-stream'),
    os = require('os');
    var current = '';
    var readingDefinition = false;
    var lineno = 1;
    var s = fs.createReadStream(path)
        .pipe(es.split())
        .pipe(es.mapSync(function(line) {
            s.pause()
            if( line.includes('stop_autodoc') && readingDefinition == true ) {
                readingDefinition = false;
                
                try {
                    // console.log('START OF THE THING',current, 'END OF THE THING')
                    chunks_output.push( JSON.parse(current) );
                } catch (error) {
                    console.log("Error in file " + path + " at line " + lineno + " , => " + error)
                    console.log(current);
                }
                current = '';                    
                
            }
            
            if(readingDefinition){
                current = current + line;
            }


            if( line.includes('start_autodoc') ) {
                readingDefinition = true;
            }
            lineno++;
            s.resume();
        })
        .on('error', function(err) {
            console.log('Error:', err);
        })
        .on('end', function() {
            // console.log('Finish reading.');
            itemsProcessed++;
            if(itemsProcessed === total_file_count) {
                allDone();
            }
        })
    );
}

var writeDocs = function(){
    var filename = process.cwd().split('/').last();
    filename = filename.replace('/','_') + '_' + file_extension + '.md';
    if (override_filename){ filename = override_filename };
    if (!fs.existsSync( doc_output_path + filename ) ){
        fs.open(doc_output_path + filename, 'w', function(err,file){})
    }
    var ws = fs.createWriteStream(doc_output_path + filename )
    console.log(doc_output_path + filename )
    ws.on('error', function(e) { console.error(e); });
    if( override_fileintro ){
        ws.write( override_fileintro + '\n \n');
    } else {
        ws.write('### Docs for ' + process.cwd().split('/').last() + "'s files in " + dir + " ending in ." + file_extension + '\n \n');
    }
    chunks_output.forEach(function(el, els, i){
        ws.write('**Chunk Name**: ' + el.name.replace(new RegExp('_', 'g'), '\\_') + '  \n');
        if (el.description) ws.write('**Usage**: ' + el.description + '  \n') ;
        if (el.fields) ws.write('**Fields**: ' + el.fields.join(', ') + '  \n');   
        ws.write('\n---\n')    
        
    })
    ws.end();
    console.log('Autodocs Complete')
}

var allDone = function(){
    // console.log(chunks_output);
    writeDocs();
}


walk(dir, callback);

if (!Array.prototype.last){
    Array.prototype.last = function(){
        return this[this.length - 1];
    };
};