#Autodoc Compiler

Compiles inline docs to markdown

##Usage

`autodoc_compile` will compile all docs in current and child directories and output markdown in PWD. 

Currently only supports the `.liquid` extension. 

### Params
` autodoc_compile [ relative directory to read || . ] [ relative directory to write the file to || . ] [ filename to write to || $pwd_liquid.md ] [ header text for the docs || "###Docs for dir's files in subdir ending in .liquid " ] `


##Inline documentation format

```
{% comment %} // just so this doesn't show in liquid
    start_autodoc // signals that the following JSON object is a definition
    {
        "name": "advice_guidance_text", // name of the content chunk
        "description": "Text for the advice and guidance section", // what the content chunk is for, where it shows, how fields are to be used.
        "fields": [ "title", "text" ] // required fields (optional, can be detailed if you want)
    }
    stop_autodoc // signals that the definition is complete
{% endcomment %} // end comment
```

If JSON is invalid compilation will fail. Be sure to escape protected characters. 